# openapi-client
API for Zarban wallet services.

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 2.0.0
- Package version: 1.0.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import openapi_client
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import openapi_client
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function

import time
import openapi_client
from openapi_client.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to https://walletapi.zarban.io
# See configuration.py for a list of all supported configuration parameters.
configuration = openapi_client.Configuration(
    host = "https://walletapi.zarban.io"
)



# Enter a context with an instance of the API client
with openapi_client.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = openapi_client.WebsocketApi(api_client)
    
    try:
        # Websocket Upgrade
        api_instance.ws_get()
    except ApiException as e:
        print("Exception when calling WebsocketApi->ws_get: %s\n" % e)
    
```

## Documentation for API Endpoints

All URIs are relative to *https://walletapi.zarban.io*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*WebsocketApi* | [**ws_get**](docs/WebsocketApi.md#ws_get) | **GET** /ws | Websocket Upgrade
*DefaultApi* | [**auth_login_post**](docs/DefaultApi.md#auth_login_post) | **POST** /auth/login | Login with email and password
*DefaultApi* | [**auth_signup_post**](docs/DefaultApi.md#auth_signup_post) | **POST** /auth/signup | signup with email and password
*DefaultApi* | [**auth_telegram_post**](docs/DefaultApi.md#auth_telegram_post) | **POST** /auth/telegram | Authenticate with Telegram
*DefaultApi* | [**balance_get**](docs/DefaultApi.md#balance_get) | **GET** /balance | Get wallet balance
*DefaultApi* | [**balance_symbol_get**](docs/DefaultApi.md#balance_symbol_get) | **GET** /balance/{symbol} | Get balance
*DefaultApi* | [**coins_get**](docs/DefaultApi.md#coins_get) | **GET** /coins | Get coins
*DefaultApi* | [**coins_symbol_get**](docs/DefaultApi.md#coins_symbol_get) | **GET** /coins/{symbol} | Get coin
*DefaultApi* | [**deposit_get**](docs/DefaultApi.md#deposit_get) | **GET** /deposit | Deposit money
*DefaultApi* | [**payments_post**](docs/DefaultApi.md#payments_post) | **POST** /payments | Create a payment
*DefaultApi* | [**points_frineds_get**](docs/DefaultApi.md#points_frineds_get) | **GET** /points/frineds | Get friends points.
*DefaultApi* | [**profile_get**](docs/DefaultApi.md#profile_get) | **GET** /profile | Get profile
*DefaultApi* | [**referrals_get**](docs/DefaultApi.md#referrals_get) | **GET** /referrals | Get referrals
*DefaultApi* | [**referrals_post**](docs/DefaultApi.md#referrals_post) | **POST** /referrals | Create a referral
*DefaultApi* | [**referrals_referral_id_get**](docs/DefaultApi.md#referrals_referral_id_get) | **GET** /referrals/{referralId} | Get referral by ID
*DefaultApi* | [**referrals_referral_id_redeem_post**](docs/DefaultApi.md#referrals_referral_id_redeem_post) | **POST** /referrals/{referralId}/redeem | Redeem a referral
*DefaultApi* | [**referrals_referral_id_validate_post**](docs/DefaultApi.md#referrals_referral_id_validate_post) | **POST** /referrals/{referralId}/validate | Validate a referral
*DefaultApi* | [**saving_deposit_post**](docs/DefaultApi.md#saving_deposit_post) | **POST** /saving/deposit | Create a saving
*DefaultApi* | [**saving_offers_get**](docs/DefaultApi.md#saving_offers_get) | **GET** /saving/offers | Get saving offers
*DefaultApi* | [**saving_positions_get**](docs/DefaultApi.md#saving_positions_get) | **GET** /saving/positions | Get saving positions
*DefaultApi* | [**saving_withdraw_post**](docs/DefaultApi.md#saving_withdraw_post) | **POST** /saving/withdraw | Withdraw saving
*DefaultApi* | [**swap_post**](docs/DefaultApi.md#swap_post) | **POST** /swap | Swap coins
*DefaultApi* | [**swap_quote_post**](docs/DefaultApi.md#swap_quote_post) | **POST** /swap/quote | post a swap quote
*DefaultApi* | [**tasks_get**](docs/DefaultApi.md#tasks_get) | **GET** /tasks | Get tasks
*DefaultApi* | [**tasks_post**](docs/DefaultApi.md#tasks_post) | **POST** /tasks | check task completion
*DefaultApi* | [**users_nickname_get**](docs/DefaultApi.md#users_nickname_get) | **GET** /users/nickname | Get nickname
*DefaultApi* | [**users_nickname_post**](docs/DefaultApi.md#users_nickname_post) | **POST** /users/nickname | Add a nickname
*DefaultApi* | [**withdraws_get**](docs/DefaultApi.md#withdraws_get) | **GET** /withdraws | Get user withdraw requests
*DefaultApi* | [**withdraws_id_get**](docs/DefaultApi.md#withdraws_id_get) | **GET** /withdraws/{id} | Get withdrawal status
*DefaultApi* | [**withdraws_preview_post**](docs/DefaultApi.md#withdraws_preview_post) | **POST** /withdraws/preview | Withdraw request
*DefaultApi* | [**withdraws_request_post**](docs/DefaultApi.md#withdraws_request_post) | **POST** /withdraws/request | Withdraw request


## Documentation For Models

 - [Balance](docs/Balance.md)
 - [Coin](docs/Coin.md)
 - [CoinConfig](docs/CoinConfig.md)
 - [CoinContent](docs/CoinContent.md)
 - [Error](docs/Error.md)
 - [ExternalTransaction](docs/ExternalTransaction.md)
 - [InlineObject](docs/InlineObject.md)
 - [InlineObject1](docs/InlineObject1.md)
 - [InlineObject10](docs/InlineObject10.md)
 - [InlineObject11](docs/InlineObject11.md)
 - [InlineObject12](docs/InlineObject12.md)
 - [InlineObject2](docs/InlineObject2.md)
 - [InlineObject3](docs/InlineObject3.md)
 - [InlineObject4](docs/InlineObject4.md)
 - [InlineObject5](docs/InlineObject5.md)
 - [InlineObject6](docs/InlineObject6.md)
 - [InlineObject7](docs/InlineObject7.md)
 - [InlineObject8](docs/InlineObject8.md)
 - [InlineObject9](docs/InlineObject9.md)
 - [InlineResponse200](docs/InlineResponse200.md)
 - [InlineResponse2001](docs/InlineResponse2001.md)
 - [InlineResponse2002](docs/InlineResponse2002.md)
 - [InlineResponse2003](docs/InlineResponse2003.md)
 - [InlineResponse2004](docs/InlineResponse2004.md)
 - [InlineResponse2005](docs/InlineResponse2005.md)
 - [InlineResponse2006](docs/InlineResponse2006.md)
 - [InlineResponse2007](docs/InlineResponse2007.md)
 - [InlineResponse2008](docs/InlineResponse2008.md)
 - [InlineResponse2009](docs/InlineResponse2009.md)
 - [Network](docs/Network.md)
 - [Payment](docs/Payment.md)
 - [Referral](docs/Referral.md)
 - [SavingDepositResponse](docs/SavingDepositResponse.md)
 - [SavingOffer](docs/SavingOffer.md)
 - [SavingWithdrawResponse](docs/SavingWithdrawResponse.md)
 - [SwapResponse](docs/SwapResponse.md)
 - [Symbol](docs/Symbol.md)
 - [Task](docs/Task.md)
 - [TelegramProfile](docs/TelegramProfile.md)
 - [Timestamp](docs/Timestamp.md)
 - [Transaction](docs/Transaction.md)
 - [TransactionStatus](docs/TransactionStatus.md)
 - [TransactionType](docs/TransactionType.md)
 - [UserError](docs/UserError.md)
 - [UserErrorMessages](docs/UserErrorMessages.md)
 - [WalletBalance](docs/WalletBalance.md)
 - [WithdrawRequest](docs/WithdrawRequest.md)
 - [WithdrawRequestPreview](docs/WithdrawRequestPreview.md)


## Documentation For Authorization


## bearerAuth

- **Type**: Bearer authentication (JWT)


## Author




