# coding: utf-8

"""
    Zarban Wallet API

    API for Zarban wallet services.  # noqa: E501

    The version of the OpenAPI document: 2.0.0
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from openapi_client.configuration import Configuration


class ExternalTransaction(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'id': 'int',
        'time': 'Timestamp',
        'type': 'TransactionType',
        'hash': 'str',
        '_from': 'str',
        'to': 'str',
        'comment': 'str',
        'amount': 'dict(str, str)',
        'symbol': 'Symbol',
        'network': 'Network',
        'status': 'TransactionStatus'
    }

    attribute_map = {
        'id': 'Id',
        'time': 'Time',
        'type': 'Type',
        'hash': 'Hash',
        '_from': 'From',
        'to': 'To',
        'comment': 'Comment',
        'amount': 'Amount',
        'symbol': 'Symbol',
        'network': 'Network',
        'status': 'Status'
    }

    def __init__(self, id=None, time=None, type=None, hash=None, _from=None, to=None, comment=None, amount=None, symbol=None, network=None, status=None, local_vars_configuration=None):  # noqa: E501
        """ExternalTransaction - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._id = None
        self._time = None
        self._type = None
        self._hash = None
        self.__from = None
        self._to = None
        self._comment = None
        self._amount = None
        self._symbol = None
        self._network = None
        self._status = None
        self.discriminator = None

        self.id = id
        self.time = time
        self.type = type
        self.hash = hash
        self._from = _from
        self.to = to
        self.comment = comment
        self.amount = amount
        self.symbol = symbol
        self.network = network
        self.status = status

    @property
    def id(self):
        """Gets the id of this ExternalTransaction.  # noqa: E501

        Unique identifier of the transaction  # noqa: E501

        :return: The id of this ExternalTransaction.  # noqa: E501
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this ExternalTransaction.

        Unique identifier of the transaction  # noqa: E501

        :param id: The id of this ExternalTransaction.  # noqa: E501
        :type: int
        """
        if self.local_vars_configuration.client_side_validation and id is None:  # noqa: E501
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def time(self):
        """Gets the time of this ExternalTransaction.  # noqa: E501


        :return: The time of this ExternalTransaction.  # noqa: E501
        :rtype: Timestamp
        """
        return self._time

    @time.setter
    def time(self, time):
        """Sets the time of this ExternalTransaction.


        :param time: The time of this ExternalTransaction.  # noqa: E501
        :type: Timestamp
        """
        if self.local_vars_configuration.client_side_validation and time is None:  # noqa: E501
            raise ValueError("Invalid value for `time`, must not be `None`")  # noqa: E501

        self._time = time

    @property
    def type(self):
        """Gets the type of this ExternalTransaction.  # noqa: E501


        :return: The type of this ExternalTransaction.  # noqa: E501
        :rtype: TransactionType
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this ExternalTransaction.


        :param type: The type of this ExternalTransaction.  # noqa: E501
        :type: TransactionType
        """
        if self.local_vars_configuration.client_side_validation and type is None:  # noqa: E501
            raise ValueError("Invalid value for `type`, must not be `None`")  # noqa: E501

        self._type = type

    @property
    def hash(self):
        """Gets the hash of this ExternalTransaction.  # noqa: E501

        The hash of the transaction  # noqa: E501

        :return: The hash of this ExternalTransaction.  # noqa: E501
        :rtype: str
        """
        return self._hash

    @hash.setter
    def hash(self, hash):
        """Sets the hash of this ExternalTransaction.

        The hash of the transaction  # noqa: E501

        :param hash: The hash of this ExternalTransaction.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and hash is None:  # noqa: E501
            raise ValueError("Invalid value for `hash`, must not be `None`")  # noqa: E501

        self._hash = hash

    @property
    def _from(self):
        """Gets the _from of this ExternalTransaction.  # noqa: E501

        The address from which the transaction originated  # noqa: E501

        :return: The _from of this ExternalTransaction.  # noqa: E501
        :rtype: str
        """
        return self.__from

    @_from.setter
    def _from(self, _from):
        """Sets the _from of this ExternalTransaction.

        The address from which the transaction originated  # noqa: E501

        :param _from: The _from of this ExternalTransaction.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and _from is None:  # noqa: E501
            raise ValueError("Invalid value for `_from`, must not be `None`")  # noqa: E501

        self.__from = _from

    @property
    def to(self):
        """Gets the to of this ExternalTransaction.  # noqa: E501

        The address to which the transaction is sent  # noqa: E501

        :return: The to of this ExternalTransaction.  # noqa: E501
        :rtype: str
        """
        return self._to

    @to.setter
    def to(self, to):
        """Sets the to of this ExternalTransaction.

        The address to which the transaction is sent  # noqa: E501

        :param to: The to of this ExternalTransaction.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and to is None:  # noqa: E501
            raise ValueError("Invalid value for `to`, must not be `None`")  # noqa: E501

        self._to = to

    @property
    def comment(self):
        """Gets the comment of this ExternalTransaction.  # noqa: E501

        A comment associated with the transaction  # noqa: E501

        :return: The comment of this ExternalTransaction.  # noqa: E501
        :rtype: str
        """
        return self._comment

    @comment.setter
    def comment(self, comment):
        """Sets the comment of this ExternalTransaction.

        A comment associated with the transaction  # noqa: E501

        :param comment: The comment of this ExternalTransaction.  # noqa: E501
        :type: str
        """

        self._comment = comment

    @property
    def amount(self):
        """Gets the amount of this ExternalTransaction.  # noqa: E501


        :return: The amount of this ExternalTransaction.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._amount

    @amount.setter
    def amount(self, amount):
        """Sets the amount of this ExternalTransaction.


        :param amount: The amount of this ExternalTransaction.  # noqa: E501
        :type: dict(str, str)
        """
        if self.local_vars_configuration.client_side_validation and amount is None:  # noqa: E501
            raise ValueError("Invalid value for `amount`, must not be `None`")  # noqa: E501

        self._amount = amount

    @property
    def symbol(self):
        """Gets the symbol of this ExternalTransaction.  # noqa: E501


        :return: The symbol of this ExternalTransaction.  # noqa: E501
        :rtype: Symbol
        """
        return self._symbol

    @symbol.setter
    def symbol(self, symbol):
        """Sets the symbol of this ExternalTransaction.


        :param symbol: The symbol of this ExternalTransaction.  # noqa: E501
        :type: Symbol
        """
        if self.local_vars_configuration.client_side_validation and symbol is None:  # noqa: E501
            raise ValueError("Invalid value for `symbol`, must not be `None`")  # noqa: E501

        self._symbol = symbol

    @property
    def network(self):
        """Gets the network of this ExternalTransaction.  # noqa: E501


        :return: The network of this ExternalTransaction.  # noqa: E501
        :rtype: Network
        """
        return self._network

    @network.setter
    def network(self, network):
        """Sets the network of this ExternalTransaction.


        :param network: The network of this ExternalTransaction.  # noqa: E501
        :type: Network
        """
        if self.local_vars_configuration.client_side_validation and network is None:  # noqa: E501
            raise ValueError("Invalid value for `network`, must not be `None`")  # noqa: E501

        self._network = network

    @property
    def status(self):
        """Gets the status of this ExternalTransaction.  # noqa: E501


        :return: The status of this ExternalTransaction.  # noqa: E501
        :rtype: TransactionStatus
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this ExternalTransaction.


        :param status: The status of this ExternalTransaction.  # noqa: E501
        :type: TransactionStatus
        """
        if self.local_vars_configuration.client_side_validation and status is None:  # noqa: E501
            raise ValueError("Invalid value for `status`, must not be `None`")  # noqa: E501

        self._status = status

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ExternalTransaction):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ExternalTransaction):
            return True

        return self.to_dict() != other.to_dict()
